<?php

namespace BoostMyShop\Agent\Block\Adminhtml;

class Base extends \Magento\Backend\Block\Widget implements \Magento\Backend\Block\Widget\Tab\TabInterface
{
    protected $_coreRegistry = null;
    protected $scopeConfig;
    protected $_webServicesHelper;

    public function __construct(
        \Magento\Backend\Block\Template\Context $context,
        \Magento\Framework\Registry $registry,
        \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfigInterface,
        \BoostMyShop\Agent\Helper\WebServices $webServicesHelper,
        array $data = []
    ) {
        $this->_coreRegistry = $registry;
        $this->scopeConfig = $scopeConfigInterface;
        $this->_webServicesHelper = $webServicesHelper;

        parent::__construct($context, $data);
    }

    public function getConnectConfig($field)
    {
        return $this->scopeConfig->getValue('erpcloud/connect/'.$field, \Magento\Store\Model\ScopeInterface::SCOPE_STORE);
    }

    public function isReadonly()
    {
        return false;
    }

    public function getTabLabel()
    {
        return __('BoostMyShop MyFulfillment');
    }

    public function getTabTitle()
    {
        return __('BoostMyShop MyFulfillment');
    }

    public function canShowTab()
    {
        return true;
    }

    public function isHidden()
    {
        return false;
    }

    public function getContentTabId()
    {
        return 'tab_content_' . $this->_blockId;
    }

    public function processRequest($uri, $method = "GET")
    {
        return $this->_webServicesHelper->processRequest($uri, $method);
    }

    public function getStatus()
    {
        try {
            $token = $this->getToken();
            return $token ? "Connected !" : "Connection error";
        } catch(\Throwable $ex) {
            return "Connection error";
        }

    }

    protected function getToken()
    {
        return $this->_webServicesHelper->getToken();
    }

    protected function _prepareLayout()
    {
        $this->setData('opened', true);
        return parent::_prepareLayout();
    }
}