<?php
namespace BoostMyShop\Agent\Block\Adminhtml\Catalog\Product\Edit\Tab;

use Magento\Catalog\Block\Adminhtml\Product\Edit\Tabs;

class ErpCloud extends \BoostMyShop\Agent\Block\Adminhtml\Base
{
    protected $_template = 'BoostMyShop_Agent::product/edit/ErpCloud.phtml';
    protected $_blockId = 'erpcloud';

    public function getGroupCode()
    {
        return Tabs::ADVANCED_TAB_GROUP_CODE;
    }

    public function getContentTabId()
    {
        return 'tab_content_' . $this->_blockId;
    }

    public function getConnectData()
    {
        try {
            $product = $this->getProduct();
            $url = "/rest/V1/erpcloud/product/?externalIds=" . $this->getProductKey($product->getId()) . "&attribute_id=0";
            $productDetail = $this->processRequest($url, "GET");

            return $productDetail;
        }
        catch(\Magento\Framework\Webapi\Exception $e)
        {
            return null;
        }
        catch(\Exception $e)
        {
            return null;
        }
    }

    public function getProduct()
    {
        return $this->_coreRegistry->registry('current_product');
    }

    protected function getProductKey($productId)
    {
        return str_pad($productId, 6, "0", STR_PAD_LEFT);
    }
}