<?php

namespace BoostMyShop\Agent\Block\Frontend;

use Magento\Framework\Registry;

class Base extends \Magento\Framework\View\Element\Template
{

    protected $_scopeConfig;
    protected $_storeManager;
    protected $_registry;
    protected $_checkoutSession;

    public function __construct(
        \Magento\Framework\View\Element\Template\Context $context,
        \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
        \Magento\Checkout\Model\Session $checkoutSession,
        \Magento\Framework\Registry $registry,
        array $data = []
    ) {
        parent::__construct($context, $data);

        $this->_scopeConfig = $scopeConfig;
        $this->_storeManager = $context->getStoreManager();
        $this->_registry = $registry;
        $this->_checkoutSession = $checkoutSession;
    }

    public function isEnabled()
    {
        return $this->getSetting('myads/enable_conversion_tag');
    }

    public function getSetting($path)
    {
        $storeId = $this->_storeManager->getStore()->getId();
        return $this->_scopeConfig->getValue('myads/'.$path, 'store', $storeId);
    }

    public function getGadId()
    {
        return $this->getSetting('myads/google_ads_id');
    }

    public function insertGtagScript()
    {
        return $this->getSetting('myads/include_gtag_script');
    }

    public function getConversionTrackingId()
    {
        return $this->getSetting('myads/conversion_tracking_id');
    }

    public function getConversionTrackingLabel()
    {
        return $this->getSetting('myads/conversion_tracking_label');
    }
}
