<?php namespace BoostMyShop\Agent\Controller\Agent;

/**
 * @copyright 2015-2018 BoostMyShop (http://www.boostmyshop.com)
 * @license   http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */

class CatalogExport extends \Magento\Framework\App\Action\Action
{
    protected $_config;
    protected $_catalogHelper;

    public function __construct(
        \Magento\Backend\App\Action\Context $context,
        \BoostMyShop\Agent\Model\Config\Agent $config,
        \BoostMyShop\Agent\Helper\Catalog $catalogHelper
    )
    {
        parent::__construct($context);
        $this->_config = $config;
        $this->_catalogHelper = $catalogHelper;
    }

    public function execute()
    {
        $token = $this->getRequest()->getParam('token');
        $tokenFromConfiguration = $this->_config->getSetting('authentication/token');

        if (!$token || $token != $tokenFromConfiguration) {
            throw new \Exception('Missing or Invalid Parameters', 400);
        }

        $configuration = [
            'storeId' => $this->getRequest()->getPostValue('storeId') ?? 0,
            'attributes' => $this->getRequest()->getPostValue('attributes') ?? []
        ];
        $filePath = $this->_catalogHelper->generate($configuration);

        if (ob_get_contents()) {
            ob_clean();
            flush();
        }

        header('Content-Type: application/xml');
        header("Content-disposition: attachment; filename=\"" . basename($filePath) . "\"");
        header('Content-Length: ' . filesize($filePath));
        readfile($filePath);
        exit();
    }
}
