<?php namespace BoostMyShop\Agent\Controller\Agent;

/**
 * @copyright 2015-2018 BoostMyShop (http://www.boostmyshop.com)
 * @license   http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */
class DownloadLogs extends \Magento\Framework\App\Action\Action
{
    protected $_config;
    protected $_directoryList;

    public function __construct(
        \Magento\Backend\App\Action\Context $context,
        \BoostMyShop\Agent\Model\Config\Agent $config,
        \Magento\Framework\Filesystem\DirectoryList $directoryList
    )
    {
        parent::__construct($context);
        $this->_config = $config;
        $this->_directoryList = $directoryList;
    }

    public function execute()
    {
        $token = $this->getRequest()->getParam('token');
        $tokenFromConfiguration = $this->_config->getSetting('authentication/token');

        if (!$token || $token != $tokenFromConfiguration) {
            throw new \Exception('Missing or Invalid Parameters', 400);
        }

        $filePath = $this->_directoryList->getPath(\Magento\Framework\App\Filesystem\DirectoryList::LOG) . '/bms-agent.log';

        header('Content-Type: text/html');
        header("Content-disposition: attachment; filename=\"" . basename($filePath) . "\"");
        header('Content-Length: ' . filesize($filePath));
        readfile($filePath);
        exit();
    }
}
