<?php namespace BoostMyShop\Agent\Controller\Agent;

/**
 * @copyright 2015-2018 BoostMyShop (http://www.boostmyshop.com)
 * @license   http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */
class GetInfo extends \Magento\Framework\App\Action\Action
{
    protected $_config;
    protected $_infoHelper;

    public function __construct(
        \Magento\Backend\App\Action\Context $context,
        \BoostMyShop\Agent\Model\Config\Agent $config,
        \BoostMyShop\Agent\Helper\Info $info
    )
    {
        parent::__construct($context);
        $this->_config = $config;
        $this->_infoHelper = $info;
    }

    public function execute()
    {
        $token = $this->getRequest()->getParam('token');
        $tokenFromConfiguration = $this->_config->getSetting('authentication/token');

        if (!$token || $token != $tokenFromConfiguration) {
            throw new \Exception('Missing or Invalid Parameters', 400);
        }


        $this->getResponse()
            ->setHeader('Content-type', 'text/html')
            ->setContent(json_encode([
                'stores' => $this->_infoHelper->getStores(),
                'attributes' => $this->_infoHelper->getAttributes()
            ]));

    }
}
