<?php namespace BoostMyShop\Agent\Controller\Agent;

/**
 * @copyright 2015-2018 BoostMyShop (http://www.boostmyshop.com)
 * @license   http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */

class PricingImport extends \Magento\Framework\App\Action\Action
{
    protected $_config;
    protected $_pricingImportHelper;

    public function __construct(
        \Magento\Backend\App\Action\Context $context,
        \BoostMyShop\Agent\Model\Config\Agent $config,
        \BoostMyShop\Agent\Helper\Pricing\Import $pricingImport
    )
    {
        parent::__construct($context);
        $this->_config = $config;
        $this->_pricingImportHelper = $pricingImport;
    }

    public function execute()
    {
        $token = $this->getRequest()->getParam('token');
        $tokenFromConfiguration = $this->_config->getSetting('authentication/token');

        if (!$token || $token != $tokenFromConfiguration) {
            throw new \Exception('Missing or Invalid Parameters', 400);
        }

        $pricings = $this->getRequest()->getPostValue('pricing');
        $configuration = $this->getRequest()->getPostValue('configuration');
        $this->_pricingImportHelper->execute($pricings, $configuration);
    }
}
