<?php namespace BoostMyShop\Agent\Helper\Catalog;

/**
 * @copyright 2015-2016 BoostMyShop (http://www.boostmyshop.com)
 * @license   http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */
class Products extends \Magento\Framework\App\Helper\AbstractHelper
{
    protected $collection;

    /** @var \Magento\Catalog\Model\ResourceModel\Product\Collection */
    protected $_collection;

    /** @var \Magento\Framework\App\ResourceConnection */
    protected $_resource;

    public function __construct(
        \Magento\Catalog\Model\ResourceModel\Product\Collection $collection,
        \Magento\Framework\App\ResourceConnection $resource,
        \Magento\Framework\App\Helper\Context $context
    )
    {
        parent::__construct($context);
        $this->_collection = $collection;
        $this->_resource = $resource;
    }

    public function getCollection($storeId, $attributes)
    {
        $this->initCollection($storeId, $attributes);
        return $this->collection;
    }

    protected function initCollection($storeId, $attributes)
    {
        $this->collection = $this->_collection
            ->setStore($storeId)
            ->setFlag('has_stock_status_filter', false)
            ->addAttributeToSelect('name')
            ->addAttributeToSelect('status')
            ->addAttributeToSelect('manufacturer')
            ->addAttributeToSelect('cost')
            ->addAttributeToSelect('price')
            ->addAttributeToSelect('weight')
            ->addAttributeToSelect('thumbnail');

        foreach ($attributes as $attribute) {
            $this->collection->addAttributeToSelect($attribute);
        }
    }
}
