<?php namespace BoostMyShop\Agent\Helper;

/**
 * @copyright 2015-2016 BoostMyShop (http://www.boostmyshop.com)
 * @license   http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */
class Info extends \Magento\Framework\App\Helper\AbstractHelper
{
    protected $_storeManager;
    protected $_productResource;

    public function __construct(
        \Magento\Store\Model\StoreManagerInterface $storeManager,
        \Magento\Catalog\Model\ResourceModel\Product $productResource,
        \Magento\Framework\App\Helper\Context $context
    )
    {
        parent::__construct($context);
        $this->_storeManager = $storeManager;
        $this->_productResource = $productResource;
    }

    public function getStores()
    {
        $stores = [];
        $magentoStores = $this->_storeManager->getStores(true);

        foreach ($magentoStores as $store) {
            $stores[] = [
                'id' => (int)$store->getId(),
                'name' => $store->getName()
            ];
        }

        return $stores;
    }

    public function getAttributes()
    {
        $attributes = [];
        $productAttributes = $this->_productResource->loadAllAttributes()->getAttributesByCode();

        foreach ($productAttributes as $attribute) {
            $attributes[] = [
                'id' => $attribute->getAttributeCode(),
                'name' => $attribute->getFrontendLabel() ?? $attribute->getAttributeCode()
            ];
        }

        return $attributes;
    }
}
