<?php namespace BoostMyShop\Agent\Model\Config;

/**
 * @copyright 2015-2018 BoostMyShop (http://www.boostmyshop.com)
 * @license   http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */
class Agent
{
    /** @var \Magento\Framework\App\Config\ScopeConfigInterface */
    protected $_scopeConfig;
    protected $_moduleManager;

    public function __construct(\Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
                                \Magento\Framework\Module\Manager $moduleManager)
    {
        $this->_scopeConfig = $scopeConfig;
        $this->_moduleManager = $moduleManager;
    }

    public function getSetting($path)
    {
        return $this->_scopeConfig->getValue('pricinglabagent/'.$path);
    }

    public function isModuleInstalled($moduleName)
    {
        return $this->_moduleManager->isEnabled($moduleName);
    }
}
