<?php
namespace BoostMyShop\Agent\Model;

use Magento\Framework\Exception\LocalizedException;

class PoManagement implements \BoostMyShop\Agent\Api\PoManagementInterface
{
    protected $_webServicesHelper;

    public function __construct
    (
        \BoostMyShop\Agent\Helper\WebServices $webServicesHelper
    ) {
        $this->_webServicesHelper = $webServicesHelper;
    }

    public function getPo($from, $limit)
    {
        $data = [];

        $orderCollectionFactory = $this->_webServicesHelper->getObjectManager("webapi_rest")->create('BoostMyShop\Supplier\Model\ResourceModel\Order\CollectionFactory');
        $poCollection = $orderCollectionFactory->create()
            ->addFieldToFilter('po_id',array('gteq' => $from));
        if($limit) {
            $poCollection->getSelect()->limit($limit);
        }
        $poCollection->getSelect()->order('po_id','ASC');

        foreach ($poCollection as $po) {
            if(!$po->getId()) {
                throw new LocalizedException(__("Purchase order not exist for this id"));
            }

            //build data array
            $dataArray = [];

            //po data
            $dataArray['data'] = $po->getData();
            //supplier
            $dataArray['supplier'] = $po->getSupplier()->getData();
            //receptions
            $receptionCollectionFactory = $this->_webServicesHelper->getObjectManager("webapi_rest")->create('BoostMyShop\Supplier\Model\ResourceModel\Order\Reception\CollectionFactory');
            $receptions = $receptionCollectionFactory->create()->addOrderFilter($po->getId());
            if($receptions){
                foreach ($receptions as $reception){
                    $dataArray['receptions'] = $reception->getData();
                }
            }
            //po products
            foreach($po->getAllItems() as $item) {
                $dataArray['products'][] = $item->getData();
            }

            $data[] = $dataArray;
        }

        return json_encode($data);
    }
}
